/***********************************************************************/
/*                                                                     */
/*  FILE        :Main.c or Main.cpp                                    */
/*  DATE        :Tue, Oct 31, 2006                                     */
/*  DESCRIPTION :Main Program                                          */
/*  CPU TYPE    :                                                      */
/*                                                                     */
/*  NOTE:THIS IS A TYPICAL EXAMPLE.                                    */
/*                                                                     */
/***********************************************************************/


//#include "typedefine.h"
#include <machine.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <mathf.h>
#include <complex.h>
#include "sound_effector.h"


#ifdef __cplusplus
//#include <ios>                        // Remove the comment when you use ios
//_SINT ios_base::Init::init_cnt;       // Remove the comment when you use ios
#endif

void main(void);
#ifdef __cplusplus
extern "C" {
void abort(void);
}
#endif

//eg`̐

void main(void)
{
	
	int n, i;
	int triangle_phase;
	
	float gain;
	
	int wave_sequence=0;	//0:TCg, 1:̂g, 2:`g, 3:Opg, 4:
	
	unsigned char prev_sw_state;
	
	
	float *sin_table;											//TCg̃e[u
	float *saw_table;											//̂g̃e[u
	float *rect_table;											//`g̃e[u
	float *triangle_table;										//Opg̃e[u
	unsigned short table_size=(unsigned short)(PCM_FS / 440);	//440Hz̃e[u쐬i440Hz, 1Ƃj
	
	//֐
	sound_effector_init();
	
	//̊m
	sin_table = calloc(table_size, sizeof(float));
	saw_table = calloc(table_size, sizeof(float));
	rect_table = calloc(table_size, sizeof(float));
	triangle_table = calloc(table_size, sizeof(float));
	
	if(sin_table == NULL || saw_table == NULL || rect_table == NULL || triangle_table == NULL)
	{
		while(1);
		//̊mۂɎs
	}
	
	//TCg̐
	for(n=0; n<table_size; n++)
	{
		sin_table[n] = sinf(2.0 * M_PI * (float)n / (float)table_size);
	}
	
	gain = 0.5;
	for(n=0; n<table_size; n++)
	{
		sin_table[n] *= gain;
	}
	
	//̂g̐
	for(i=1; i<=48; i++)
	{
		for(n=0; n<table_size; n++)
		{
			saw_table[n] += 1.0 / (float)i * sinf(2.0 * M_PI * (float)i * (float)n / (float)table_size);
		}
	}
	
	gain = 0.5;
	for(n=0; n<table_size; n++)
	{
		saw_table[n] *= gain;
	}
	
	//`g̐
	for(i=1; i<=48; i+=2)
	{
		for(n=0; n<table_size; n++)
		{
			rect_table[n] += 1.0 / (float)i * sinf(2.0 * M_PI * (float)i * (float)n / (float)table_size);
		}
	}
	
	gain = 0.5;
	for(n=0; n<table_size; n++)
	{
		rect_table[n] *= gain;
	}
	
	//Opg`̐
	triangle_phase=0;
	for(i=1; i<=48; i+=2)
	{
		for(n=0; n<table_size; n++)
		{
			if(triangle_phase % 2 == 0)		//i=3,7,11,...ł͈ʑ180x炵i]jg`dˍ킹
			{
				triangle_table[n] += 1.0 / (float)i / (float)i * sinf(2.0 * M_PI * (float)i * (float)n / (float)table_size);
			}
			else
			{
				triangle_table[n] -= 1.0 / (float)i / (float)i * sinf(2.0 * M_PI * (float)i * (float)n / (float)table_size);
			}
		}
		triangle_phase++;
	}
	
	gain = 0.5;
	for(n=0; n<table_size; n++)
	{
		triangle_table[n] *= gain;
	}
	
	g_outbuf_end=table_size-1;		//s[gݒi0`table_size-1܂ŏo͂܂j
	
	sound_effector_start();			//Jn
	
	prev_sw_state = g_sw_state;		//Push-SW̏Ԃۑ
	
	
	while(1)
	{
		if(prev_sw_state != g_sw_state)
		{
			//Push-SWꂽ
			
			g_data_out_flag=DATA_OUT_HOLD;		//o͒~
			g_outbuf_rp = 0;					//o͊Jn_0
			
			switch(wave_sequence)
			{
				case 0:
					for(n=0; n<table_size; n++)
					{
						g_outbuf[n] = clipping_data_norm(sin_table[n]);	//o̓obt@ɏo͒lZbg
					}
#ifdef DEBUG
					//ErrLED_ł
					g_err_led_patturn = 0x000000001;
#endif
					break;
				
				case 1:
					for(n=0; n<table_size; n++)
					{
						g_outbuf[n] = clipping_data_norm(saw_table[n]);	//o̓obt@ɏo͒lZbg
					}
#ifdef DEBUG
					//ErrLED_łi2j
					g_err_led_patturn = 0x000000005;
#endif
					break;
			
				case 2:
					for(n=0; n<table_size; n++)
					{
						g_outbuf[n] = clipping_data_norm(rect_table[n]);	//o̓obt@ɏo͒lZbg
					}
#ifdef DEBUG
					//ErrLED_łi3j
					g_err_led_patturn = 0x000000015;
#endif
					break;
				
				case 3:
					for(n=0; n<table_size; n++)
					{
						g_outbuf[n] = clipping_data_norm(triangle_table[n]);	//o̓obt@ɏo͒lZbg
					}
#ifdef DEBUG
					//ErrLED_łi4j
					g_err_led_patturn = 0x000000055;
#endif
					break;
				
				case 4:
					for(n=0; n<table_size; n++)
					{
						g_outbuf[n] = 0;	//f[^
					}
#ifdef DEBUG
					//ErrLED_
					g_err_led_patturn = LED_ON;
#endif
					break;
			}
			
			g_data_out_flag=DATA_OUT;		//o̓X^[g
			
			wave_sequence++;
			if(wave_sequence >= 5) wave_sequence = 0;
			
			prev_sw_state = g_sw_state;		//XCb`̏Ԃۑ
			
		}
			
		nop();

	}//while
}

#ifdef __cplusplus
void abort(void)
{

}
#endif
